<?php
/**
 * @package     CSVI
 * @subpackage  HikaShop
 *
 * @author      RolandD Cyber Produksi <contact@rolandd.com>
 * @copyright   Copyright (C) 2006 - @year@ RolandD Cyber Produksi. All rights reserved.
 * @license     GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 * @link        https://rolandd.com
 */

use Joomla\CMS\Form\FormHelper;

defined('_JEXEC') or die;

FormHelper::loadFieldClass('CsviForm');

/**
 * Select list form field with product categories.
 *
 * @package     CSVI
 * @subpackage  HikaShop
 * @since       6.0
 */
class JFormFieldCsviHikashopProductCategories extends JFormFieldCsviForm
{
	/**
	 * Type of field
	 *
	 * @var    string
	 * @since  4.0
	 */
	protected $type = 'CsviHikashopProductCategories';

	/**
	 * Select categories.
	 *
	 * @return  array  An array of users.
	 *
	 * @since   4.0
	 */
	protected function getOptions()
	{
		require_once JPATH_PLUGINS . '/csviaddon/hikashop/com_hikashop/helper/com_hikashop_category.php';

		$helper = new Com_HikashopHelperCom_Hikashop_Category($this->db);
		$filter = array(
			$this->db->quoteName('category_name', 'text'),
			$this->db->quoteName('category_id', 'value'),
			$this->db->quoteName('category_depth')
		);
		$options = $helper->getChildren('product', true, [], 'a.category_left', false, false, false, $filter);

		// Make the categories look pretty
		foreach ($options as $key => $option)
		{
			if ($option->category_depth > 0)
			{
				$options[$key]->text = str_repeat('>', ($option->category_depth - 1)) . ' ' . $option->text;
			}
		}

		if (empty($options))
		{
			$options = array();
		}

		return array_merge(parent::getOptions(), $options);
	}
}
